script.on_init(function()
	if remote.interfaces["dota_scenario_running"] then
		global.scenario = true
	else
		global.scenario = false
	end
	global.healing_per_tick = 0.15
	global.healing_tweak = settings.startup["dota_regeneration_hack"].value
	global.version = 1
end)

script.on_configuration_changed(function()
	if global.scenario then return end
--	global.healing_per_tick = game.entity_prototypes["character"].healing_per_tick*3
	global.healing_per_tick = 0.15
	global.healing_tweak = settings.startup["dota_regeneration_hack"].value
	if not global.version then
		for _, surface in pairs(game.surfaces) do
			local trees = surface.find_entities_filtered{type="tree"}
			for _, tree in pairs(trees) do
				if string.sub(tree.name,1,9) == "dotatree-" then
					local color = tree.tree_color_index 
					local variation = tree.graphics_variation
					local position = tree.position
					local stage = tree.tree_stage_index 
					local name = string.sub(tree.name,10)
					tree.destroy()
					local newtree = game.surfaces[1].create_entity{name = name, position = position}
					newtree.graphics_variation = variation
					newtree.tree_color_index = color
					newtree.tree_stage_index = stage
				end
			end
		end
		global.version = 1
	end
end)
script.on_nth_tick(3, function()
	if global.healing_tweak and not global.scenario then
		for _, player in pairs(game.players) do
			if player.character and player.character.valid and not player.character.in_combat then
				player.character.health = player.character.health + global.healing_per_tick
			end
		end
	end
end)