local grid =   {
    type = "equipment-grid",
    name = "dota-equipment-grid",
    width = 2,
    height = 1,
    equipment_categories = {"armor"}
  }

local mk1 = table.deepcopy(data.raw.armor["light-armor"])
mk1.name = "dotaarmor-"..mk1.name
mk1.localised_name = "Light Armor*"
mk1.equipment_grid = "dota-equipment-grid"
if not mk1.flags then 
	mk1.flags = {"hidden"}
else
	table.insert(mk1.flags, "hidden")
end

local mk1_rec = table.deepcopy(data.raw.recipe["light-armor"])
mk1_rec.name = mk1.name
mk1_rec.result = mk1.name
mk1_rec.enabled = false

local mk2 = table.deepcopy(data.raw.armor["heavy-armor"])
mk2.name = "dotaarmor-"..mk2.name
mk2.localised_name = "Heavy Armor*"
mk2.equipment_grid = "dota-equipment-grid"
if not mk2.flags then 
	mk2.flags = {"hidden"}
else
	table.insert(mk2.flags, "hidden")
end

local mk2_rec = table.deepcopy(data.raw.recipe["heavy-armor"])
mk2_rec.name = mk2.name
mk2_rec.result = mk2.name

local reactor = table.deepcopy(data.raw["generator-equipment"]["fusion-reactor-equipment"])
reactor.name = "dota-reactor-1x1"
reactor.localised_name = "Reactor 1x1"
reactor.take_result = reactor.name
reactor.shape =
    {
      width = 1,
      height = 1,
      type = "full"
    }
local reactor_item = table.deepcopy(data.raw.item["fusion-reactor-equipment"])
reactor_item.name = reactor.name
reactor_item.placed_as_equipment_result = reactor.name
reactor_item.localised_name = "Reactor 1x1"
if not reactor_item.flags then 
	reactor_item.flags = {"hidden"}
else
	table.insert(reactor_item.flags, "hidden")
end

local roboport = table.deepcopy(data.raw["roboport-equipment"]["personal-roboport-mk2-equipment"])
roboport.name = "dota-roboport-1x1"
roboport.localised_name = "Roboport 1x1"
roboport.take_result = roboport.name
roboport.shape = 
	{
      width = 1,
      height = 1,
      type = "full"
    }
local roboport_item = table.deepcopy(data.raw.item["personal-roboport-mk2-equipment"])
roboport_item.name = roboport.name
roboport_item.placed_as_equipment_result = roboport.name
roboport_item.localised_name = "Roboport 1x1"
if not roboport_item.flags then 
	roboport_item.flags = {"hidden"}
else
	table.insert(roboport_item.flags, "hidden")
end
data:extend({
	grid,
	mk1,
	mk1_rec,
	mk2,
	mk2_rec,
	reactor,
	reactor_item,
	roboport,
	roboport_item

})