local items = {
	"dota_shoes",
	"dota_golden_amulet",
	"dota_health_potion",
	"dota_spineripper",
	"dota_tyrs_hand",
	"dota_bulwark",
	"dota_spiked_collar",
	"dota_horned_helmet",
	"dota_yellow_ammo",
	"dota_red_ammo",
	"dota_green_ammo",
	"dota_book1",
	"dota_iron_generator",
	"dota_iron_plates_generator",
	"dota_copper_generator",
	"dota_copper_plates_generator",
	"dota_stone_generator",
	"dota_stone_bricks_generator",
	"dota_uranium_generator",
	"dota_coal_generator",
	"dota_attackspeed_0",
	"dota_damage_0",
	"dota_damage_1",
	"dota_armor_0",
	"dota_health_0",
	"dota_health_1",
	"dota_armor_health",
	"dota_boots_0",
	"dota_boots_1",
	"dota_boots_2",
	"dota_regeneration_0",
	"dota_rainbow_drill",
	"dota_chardamage_0",
	"dota_chardamage_gold",
	"dota_chardamage_gold_reg",
	"dota_amnesia_book",
	"dota_mana_potion",
	"dota_mana_0",
	"dota_manareg_0",
}
local extend = {}
for _, name in pairs(items) do
	table.insert(extend, 
	{
		type = "sprite",
		name = name,
		filename = "__dota__/graphics/items/"..name..".png",
		priority = "extra-high-no-scale",
		width = 64,
		height = 64,
		flags = {"no-crop", "icon"},
		scale = 1
	})
end
table.insert(extend, 
	{
		type = "sprite",
		name = "dota-coin",
		filename = "__dota__/graphics/coin.png",
		priority = "extra-high-no-scale",
		width = 177,
		height = 148,
		flags = {"no-crop", "icon"},
		scale = 1
	})
table.insert(extend, 
	{
		type = "sprite",
		name = "transparent32",
		filename = "__dota__/graphics/transparent32.png",
		priority = "extra-high-no-scale",
		width = 32,
		height = 32,
		flags = {"no-crop", "icon"},
		scale = 1
	})
data:extend(extend)

require ("unused_items")