script.on_event(defines.events.on_gui_click, function(event)
	if not event.element then return end
	if event.element.parent and event.element.parent.parent and event.element.parent.parent.name == "itemselector" and event.element.parent.parent.parent and event.element.parent.parent.parent.name == "dota_item_market" then
		--for a,b in pairs(global.database[event.element.name].raw) do
		--game.print(a.." "..b)
		--game.print(event.element.parent.name)
		--end
		local bought_amount = 1
		if event.shift then
			bought_amount = game.item_prototypes[event.element.name].stack_size
		elseif event.button == defines.mouse_button_type.right then
			bought_amount = 5
		end
		local b = 0
		for i=1, bought_amount do
			if global.players[event.player_index].money > event.element.number then
				game.players[event.player_index].insert{name = event.element.name, count = 1}
				global.players[event.player_index].money = global.players[event.player_index].money - event.element.number
				b=b+1
			end
		end
		--game.players[event.player_index].print({"","bought ",b,"x ",{"item-name."..event.element.name}}) --too complicated .. meh
		local player_item_count = game.players[event.player_index].get_main_inventory().get_item_count(event.element.name)
		game.players[event.player_index].print("bought "..b.."x "..event.element.name.." ("..player_item_count..")"..string.rep(" ", game.tick%180))
	end
	if event.element.parent and event.element.parent.name == "itemgroups" and event.element.parent.parent and event.element.parent.parent.name == "dota_item_market" then
		event.element.parent.parent.itemselector.clear()
		fill_item_selector(event.element.parent.parent.itemselector, game.players[event.player_index], event.element.name)
	end
		
	if event.element.name == "dotamarket_pause" then
		for _, player in pairs(game.players) do
			if player.gui.top.dotamarket_updater then
				if global.pauseupdate then
					player.gui.top.dotamarket_updater.header.dotamarket_pause.sprite = "dotamarket_pause"
				else
					player.gui.top.dotamarket_updater.header.dotamarket_pause.sprite = "dotamarket_play"
				end
			end
		end
		global.pauseupdate = not global.pauseupdate
	end
	local player_id = event.element.player_index
	local player = game.players[player_id]
	if event.element.name:sub(1,16) == "dota-readycheck-" then
		if global.lobby_teams.red[player_id]~=nil then
			global.lobby_teams.red[player_id] = event.element.state
		elseif global.lobby_teams.blue[player_id]~=nil then
			global.lobby_teams.blue[player_id] = event.element.state
		--elseif global.lobby_teams.unassigned[player_id] then
		--	global.lobby_teams.unassigned[player_id] = event.element.state
		end
		update_lobbys()
	elseif event.element.name == "dota_red_button" then
		global.lobby_teams.red[player_id] = false
		global.lobby_teams.blue[player_id] = nil
		global.lobby_teams.unassigned[player_id] = nil
		update_lobbys()
	elseif event.element.name == "dota_blue_button" then
		global.lobby_teams.red[player_id] = nil
		global.lobby_teams.blue[player_id] = false
		global.lobby_teams.unassigned[player_id] = nil
		update_lobbys()
	elseif event.element.name == "dota_blue_straggler" then
		player.gui.center.straggler_gui.destroy()
		create_player(player, "blue")
		update_stragglers()
	elseif event.element.name == "dota_red_straggler" then
		player.gui.center.straggler_gui.destroy()
		create_player(player, "red")
		update_stragglers()
	elseif global.items[event.element.name] and event.element.parent.name == "market_buy_item" then
		buy_item(player, event.element.name)
	elseif global.items[event.element.name] and event.element.parent.name == "market_table" then
		if event.button == defines.mouse_button_type.right then
			buy_item(player, event.element.name)
		else
			open_market(player, event.element.name)
		end
	elseif event.element.type == "sprite-button" and global.items[event.element.sprite] and event.element.parent.name == "equipment_table" and event.button == defines.mouse_button_type.right and player.gui.center.dota_market then
		--if global.players[player.index].money > global.items[event.element.name].price and table_length(global.players[player.index]) < 6 then
			local once = false
			for i, data in pairs( global.players[player.index].items ) do
				if not once then
					if data.item ==event.element.sprite then
						if data.count == 1 then
							global.players[player.index].items[i] = nil
							once = true
						else
							data.count = data.count - 1
							once = true
						end
					end
				end
			end
			if once then
				global.players[player.index].items = sort_items(global.players[player.index].items)
				global.players[player.index].money = global.players[player.index].money + get_sell_price(event.element.sprite) * 0.8
				player.gui.left.dota_item_gui.money.caption = math.floor(global.players[player.index].money).."[img=dota-coin]"
				update_items(player)
				open_market(player)
			end
		--end
	elseif event.element.type == "sprite-button" and global.items[event.element.sprite] and event.element.parent.name == "equipment_table" and not player.gui.center.dota_market and (not global.players[player.index].item_cooldowns[event.element.sprite]) then
		if global.items[event.element.sprite].cooldown then
			global.players[player.index].item_cooldowns[event.element.sprite] = global.items[event.element.sprite].cooldown
			global.items[event.element.sprite].func(player)
			if global.items[event.element.sprite].consumed then
				for i, data in pairs(global.players[player.index].items) do
					if data.item == event.element.sprite then
						if data.count == 1 then
							global.players[player.index].items[i] = nil
						else
							global.players[player.index].items[i].count = data.count-1
						end
					end
				end
				update_items(player)
			end
		end
	end
	talents_gui_click(event)
end)

function straggler_gui(player)
	if player.gui.center.straggler_gui then
		player.gui.center.straggler_gui.destroy()
	end
	local gui = player.gui.center.add{type="frame", name = "straggler_gui", direction = "vertical"}
	local table = gui.add{type = "table", name = "table", column_count = 2}
	table.add{type = "button", name = "dota_red_straggler", caption = "Red"}
	table.add{type = "button", name = "dota_blue_straggler", caption = "Blue"}
	local red_flow = table.add{type = "flow", name = "red_flow", direction = "vertical"}
	local blue_flow = table.add{type = "flow", name = "blue_flow", direction = "vertical"}
	for id, player in pairs(global.players) do
		local cap table[player.color.."_flow"].add{type = "label", name = id, caption = game.players[id].name}
		if not game.players[id].connected then
			cap.style.font_color = {r=0.5,g=0.5,b=0.5}
		end
	end
	
end
function update_stragglers()
	for _, player in pairs(game.players) do
		if player.gui.center.straggler_gui then
			straggler_gui(player)
		end
	end
end
function create_lobby(player)
	global.lobby_teams.red[player.index] = nil
	global.lobby_teams.blue[player.index] = nil
	global.lobby_teams.unassigned[player.index] = false
	local gui = player.gui.center.add{type="frame", name="lobby", direction = "vertical"}
	global.lobbys[player.index] = gui
	local table = gui.add{type="table", name="table", direction = "vertical", column_count = 2}
	table.add{type = "button", name = "dota_red_button", caption = "Red"}
	--table.dota_red_button.style.width = 120
	table.add{type = "button", name = "dota_blue_button", caption = "Blue"}
	--table.dota_blue_button.style.width = 120
	local red_flow = table.add{type = "flow", name = "red_flow", direction = "vertical"}
	red_flow.style.minimal_height = 150
	local blue_flow = table.add{type = "flow", name = "blue_flow", direction = "vertical"}
	blue_flow.style.minimal_height = 150
	gui.add{type="label", name="caption_unassigned", direction = "vertical", caption = "unassigned:"}
	gui.caption_unassigned.style.top_margin = 30
	local unassigned_flow = gui.add{type = "flow", name = "unassigned_flow", direction = "vertical"}
	update_lobbys()
end
function update_lobbys()
	for _, lobby in pairs(global.lobbys) do
		lobby.table.red_flow.clear()
		for id, state in pairs(global.lobby_teams.red) do
			if game.players[id].connected then
				local flow = lobby.table.red_flow.add{type = "flow", name = id, direction = "horizontal"}
				local check = flow.add{type = "checkbox", name = "dota-readycheck-"..id, state = state}
				if id ~=lobby.player_index then
					check.ignored_by_interaction = true
				end
				local label = flow.add{type = "label", name = id, caption = game.players[id].name}
				--label.style.width = 100
			end
		end
		lobby.table.blue_flow.clear()
		for id, state in pairs(global.lobby_teams.blue) do
			if game.players[id].connected then
				local flow = lobby.table.blue_flow.add{type = "flow", name = id, direction = "horizontal"}
				local check = flow.add{type = "checkbox", name = "dota-readycheck-"..id, state = state}
				if id ~=lobby.player_index then
					check.ignored_by_interaction = true
				end
				local label = flow.add{type = "label", name = id, caption = game.players[id].name}
				--label.style.width = 100
			end
		end
		lobby.unassigned_flow.clear()
		for id, state in pairs(global.lobby_teams.unassigned) do
			if game.players[id].connected then
				local flow = lobby.unassigned_flow.add{type = "flow", name = id, direction = "horizontal"}
				flow.add{type = "label", name = id, caption = game.players[id].name}
				--local check = flow.add{type = "checkbox", name = "check"..id, state = state}
				--if id ==lobby.player_index then
				--	check.ignored_by_interaction = true
				--end
			end
		end
		local i = 0
		for id in pairs(global.lobby_teams.unassigned) do
			if game.players[id].connected then
				i=i+1
			end
		end
		if i ==0 then
			lobby.caption_unassigned.caption = ""
		else
			lobby.caption_unassigned.caption = "unassigned:"
		end
	end
	readycheck()
end
function readycheck()
	local i = 0
	for id in pairs(global.lobby_teams.unassigned) do
		if game.players[id].connected then
			i=i+1
		end
	end
	if i >0 then
		global.countdown = nil
		return
	end
	for _, state in pairs(global.lobby_teams.red) do
		if not state then
			global.countdown = nil
			return
		end
	end
	for _, state in pairs(global.lobby_teams.blue) do
		if not state then
			global.countdown = nil
			return
		end
	end
	global.countdown = 10
end